module Colorlib
  class ColoredCompound

    @@makers = {}

    def initialize
      @strings = []
    end

    def append(whatever)
      @strings << whatever.is_a?(ColoredString) ? whatever : ColoredString.new(whatever.to_s)
      self # to return it
    end

    alias :<< :append

    def make(target)
      unless (maker = @@makers[target])
        raise 'Invalid Target'
      end
      prev = ColorAttribute.new
      ret = ''
      @strings.each do |string|
        ret += maker.call string, prev
      end
      ret
    end

    def self.register_maker(type, &block)
      @@makers[type] = block
    end

  end
end